// *** CodeOnlyControl flag can be used to define control in code
// *** Make sure to comment the declarative definition in ASPX page
//#define CodeOnlyControl

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;

using Westwind.Web.Controls;

public partial class ControlDemo : System.Web.UI.Page
{
    protected string Test = "Hello";
    protected int Value = 2;

    protected AddressClass Address = new AddressClass();

#if CodeOnlyControl
    protected PreservePropertyControl Persister = null;
#endif

    protected void Page_Load(object sender, EventArgs e)
    {

#if CodeOnlyControl
        // *** To declare in code comment the declarative definition
        // *** in the ASPX page and use this code instead (which is identical
        // *** to the control definition there).
        Persister = new PreservePropertyControl();
        Persister.ID = "Persister";
        this.Controls.Add(Persister);

        this.Persister.PreserveProperty(this.btnSubmit, "ForeColor");
        this.Persister.PreserveProperty(this.lblMessage2, "BackColor");
#endif

        // *** Explicit adding properties wroks in code as well
        this.Persister.PreserveProperty(this, "Test");
        this.Persister.PreserveProperty(this, "Value");
        this.Persister.PreserveProperty(this, "Address");
        
        
        //*** Not Serializable
        // this.Persister.PreserveProperty(this.btnSubmit,"Style");

    }

    protected override void OnPreRender(EventArgs e)
    {
        // *** Always echo back persisted values
        this.lblMessage.Text = "Persisted properties of the Page:<br>" +
                               "Test & Value Properties: " + this.Test + "  " + this.Value.ToString() + "<br>" +
                               "Address Business Object: " + Address.Street + " SomeValue: " + Address.SomeValue.ToString();
        base.OnPreRender(e);
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        this.Address.SomeValue = -333.3333M;
        this.btnSubmit.ForeColor = Color.FromName(this.txtColor.Text);
        this.lblMessage2.BackColor = Color.FromName(this.txtColor.Text);
        this.Test = "New Value";
        this.Value = 10;
        this.Address.Street = "301 N. 15th Street";


    }

}
